Index: quintagroup.themetemplate/trunk/quintagroup/themetemplate/README.txt
===================================================================
--- quintagroup.themetemplate/trunk/quintagroup/themetemplate/README.txt	(revision 1360)
+++ quintagroup.themetemplate/trunk/quintagroup/themetemplate/README.txt	(revision 1363)
@@ -669,4 +669,6 @@
     Recursing into profiles
     ...
+    Inserting from profiles.zcml_insert ...
+    ...
     Inserting from setuphandlers.py_insert into ...
     ...
@@ -675,4 +677,5 @@
    - 'import' directory was added into root of the theme
    - profiles stuff was updated
+   - profiles.zcml file is updated
    - some stuff into setuphandlers.py module was inserted
     
@@ -684,13 +687,14 @@
 
 
-2. import_steps.xml was added in profiles/default directory (if does not exist yet),
+2. import_steps.xml was added in profiles/import_zexps directory,
    which contains additional *quintagroup.theme.ploneexample.import_zexps* step.
 
-    >>> 'import_steps.xml' in os.listdir('profiles/default')
-    True
-
-    >>> cat('profiles/default/import_steps.xml')
-    <?xml version="1.0"?>
-    <import-steps>
+    >>> 'import_zexps' in os.listdir('profiles')
+    True
+    >>> 'import_steps.xml' in os.listdir('profiles/import_zexps')
+    True
+
+    >>> cat('profiles/import_zexps/import_steps.xml')
+    <?xml version="1.0"?>
     ...
       <import-step id="quintagroup.theme.ploneexample.import_zexps"
@@ -698,11 +702,26 @@
                    handler="quintagroup.theme.ploneexample.setuphandlers.importZEXPs"
                    title="My Theme Name: Import zexps objects">
-        <dependency step="skins" />
         Import zexp objects into portal on My Theme Name theme installation
       </import-step>
     <BLANKLINE>
-    </import-steps>
-
-3. Check setuphandlers.py module - there must be importZEXPs function defined
+    ...
+
+3. profiles.zcml configuration updated with new genericsetup profile for zexps
+   importing.
+
+    >>> cat('profiles.zcml')
+    <configure
+    ...
+      <genericsetup:registerProfile
+        name="import_zexps"
+        title="My Theme Name: Import ZEXPs"
+        directory="profiles/import_zexps"
+        description='Extension profile for importing objects of the "My Theme Name" Plone theme.'
+        provides="Products.GenericSetup.interfaces.EXTENSION"
+        />
+    <BLANKLINE>
+    ...
+    
+4. Check setuphandlers.py module - there must be importZEXPs function defined
 
     >>> cat('setuphandlers.py')
Index: quintagroup.themetemplate/trunk/quintagroup/themetemplate/localcommands/templates/importing/profiles.zcml_insert
===================================================================
--- quintagroup.themetemplate/trunk/quintagroup/themetemplate/localcommands/templates/importing/profiles.zcml_insert	(revision 1363)
+++ quintagroup.themetemplate/trunk/quintagroup/themetemplate/localcommands/templates/importing/profiles.zcml_insert	(revision 1363)
@@ -0,0 +1,9 @@
+
+  <genericsetup:registerProfile
+      name="import_zexps"
+      title="${qplone3_theme_skinname}: Import ZEXPs"
+      directory="profiles/import_zexps"
+      description='Extension profile for importing objects of the "${qplone3_theme_skinname}" Plone theme.'
+      provides="Products.GenericSetup.interfaces.EXTENSION"
+      />
+
Index: quintagroup.themetemplate/trunk/quintagroup/themetemplate/localcommands/templates/importing/profiles/import_zexps/import_steps.xml_insert
===================================================================
--- quintagroup.themetemplate/trunk/quintagroup/themetemplate/localcommands/templates/importing/profiles/import_zexps/import_steps.xml_insert	(revision 1363)
+++ quintagroup.themetemplate/trunk/quintagroup/themetemplate/localcommands/templates/importing/profiles/import_zexps/import_steps.xml_insert	(revision 1363)
@@ -0,0 +1,12 @@
+#<?xml version="1.0"?>
+#<import-steps>
+#if not $already_used:
+  <import-step id="${namespace_package}.${namespace_package2}.${package}.import_zexps"
+               version="${timestamp}-01"
+               handler="${namespace_package}.${namespace_package2}.${package}.setuphandlers.importZEXPs"
+               title="${qplone3_theme_skinname}: Import zexps objects">
+    Import zexp objects into portal on ${qplone3_theme_skinname} theme installation
+  </import-step>
+#end if
+
+#</import-steps>
Index: quintagroup.themetemplate/trunk/quintagroup/themetemplate/templates/qplone3_theme/+namespace_package+/+namespace_package2+/+package+/profiles.zcml_tmpl
===================================================================
--- quintagroup.themetemplate/trunk/quintagroup/themetemplate/templates/qplone3_theme/+namespace_package+/+namespace_package2+/+package+/profiles.zcml_tmpl	(revision 1360)
+++ quintagroup.themetemplate/trunk/quintagroup/themetemplate/templates/qplone3_theme/+namespace_package+/+namespace_package2+/+package+/profiles.zcml_tmpl	(revision 1363)
@@ -14,5 +14,5 @@
   <genericsetup:registerProfile
       name="uninstall"
-      title="Uninstall $skinname"
+      title="${skinname}: Uninstall"
       directory="profiles/uninstall"
       description='Uninstallation profile for the "${skinname}" Plone theme.'
@@ -20,3 +20,6 @@
       />
 
+  <!-- Extra configurations -->
+  <!-- -*- extra stuff goes here -*- -->
+
 </configure>