Index: /quintagroup.themetemplate/trunk/docs/HISTORY.txt
===================================================================
--- /quintagroup.themetemplate/trunk/docs/HISTORY.txt	(revision 1363)
+++ /quintagroup.themetemplate/trunk/docs/HISTORY.txt	(revision 1364)
@@ -1,4 +1,21 @@
 Changelog
 =========
+
+0.2.2 (unreleased)
+------------------
+
+- Updated import_zexps subtemplate - move this step into
+  separate genericsetup profile
+  [mylan]
+- Updated tests for changed import_zexps subtemplate
+  [mylan]
+
+0.2 (unreleased)
+----------------
+
+- Added new css_dtml_skin subtemplate
+  [mylan]
+- Added tests for css_dtml_skin subtemplate
+  [mylan]
 
 0.14 (unreleased)
Index: /quintagroup.themetemplate/trunk/quintagroup.themetemplate.egg-info/PKG-INFO
===================================================================
--- /quintagroup.themetemplate/trunk/quintagroup.themetemplate.egg-info/PKG-INFO	(revision 1363)
+++ /quintagroup.themetemplate/trunk/quintagroup.themetemplate.egg-info/PKG-INFO	(revision 1364)
@@ -1,5 +1,5 @@
 Metadata-Version: 1.0
 Name: quintagroup.themetemplate
-Version: 0.9dev
+Version: 0.2.2
 Summary: Quintagroup theme template for Plone 3 with nested namespace
 Home-page: http://svn.quintagroup.com/products/quintagroup.themetemplate
@@ -10,4 +10,13 @@
         ======================
         
+        quintagroup.themetemplate is an enhanced "Plone 3 Theme" template from Zopeskel,
+        that includes addcontent local command, which allows you to extend base Plone theme
+        by additional elements, such as: skin layers, portlets, viewlets, css and js resources,
+        and objects in zexp files. This package is an analogue of Archetype template in terms
+        of its functionality.
+        
+        quintagroup.themetemplate package is used for development of all Quintagroup themes
+        for Plone 3 (http://skins.quintagroup.com).
+        
         Contents
         --------
@@ -20,7 +29,9 @@
         ========
         
-        This theme template allows you to create plone3 theme python package
-        with nested namespace. Initial package is theme package skeleton.
-        This package can be extended (filled in) with:
+        This theme template allows you to create initial theme package skeleton,
+        i.e. create plone3 theme python package with nested namespace (this is different from
+        deafult plone3_theme template in Zopeskel)
+        
+        After that you can extend theme package by the following elements:
         
         - skin-layer(s)
@@ -28,4 +39,5 @@
         - viewlet(s)
         - css, js resource(s)
+        - objects in zexp files
         
         Creation of a package is performed with *paster create* PasteScript command.
@@ -65,4 +77,5 @@
         
         So check namespaces::
+        
         >>> theme_namespace = os.path.join(package_dir,'quintagroup','theme','ploneexample')
         >>> os.path.isdir(theme_namespace)
@@ -70,4 +83,5 @@
         
         Theme holds 3 subdirectories (browser, profiles, skins)::
+        
         >>> cd(theme_namespace)
         >>> dirs = ('skins', 'browser', 'profiles')
@@ -76,4 +90,5 @@
         
         And initialization files (__init__.py, configure.zcml) ::
+        
         >>> files = ('__init__.py', 'configure.zcml')
         >>> [True for d in files if d in os.listdir('.')]
@@ -206,5 +221,5 @@
         One of the best features, which ZopeSkel package brings, is *localcommand*.
         
-        In this part I will show how you can extend a theme (generated with qplone3_theme
+        This part shows how you can extend a theme (generated with qplone3_theme
         ZopeSkel template) with additional useful stuff:
         
@@ -215,4 +230,5 @@
         - css
         - javascripts
+        - objects in zexp files
         
         So, in qplone3_theme generated package you can use *addcontent* ZopeSkel
@@ -226,4 +242,5 @@
         paster addcontent -a
         ...
+        css_dtml_skin:   A DTML file in skin layer with CSS registration
         css_resource:    A Plone 3 CSS resource template
         ...
@@ -408,4 +425,61 @@
         
         
+        Adding CSS resource as dtml-file into skins layer
+        =================================================
+        
+        This template actually absolutely same to the previouse one, but layer_name
+        variable added to point in which skin layer css dtml-file should be added to.
+        And, of course, css resource added into pointing *skins/<layer_name>/<css_reseource_name>.dtml* file.
+        
+        This subtemplate has several benefits before registering css as resource layer:
+        - in dtml file you can use power of dtml language
+        - this resource can be overriden by customer if he needs that
+        
+        IMPORTANT:
+        For add css resource in registered skin layer - you should use this subtemplate
+        in conjunction with *skin_layer* one.
+        
+        
+        Use *css_dtml_skin* subtemplate.
+        
+        >>> paster("addcontent --no-interactive css_dtml_skin")
+        paster addcontent --no-interactive css_dtml_skin
+        Recursing into profiles
+        ...
+        Recursing into skins
+        ...
+        
+        This template adds main.css.dtml file into skins/skin_layer folder
+        
+        >>> 'main.css.dtml' in os.listdir('skins/skin_layer')
+        True
+        
+        The main.css.dtml file already prepared to use as dtml-document
+        >>> cat('skins/skin_layer/main.css.dtml')
+        /*
+        ...
+        /* <dtml-with base_properties> (do not remove this :) */
+        ...
+        /* </dtml-with> */
+        <BLANKLINE>
+        
+        
+        And cssregistry.xml profile was added into profiles/default directory with
+        registered main.css stylesheet
+        
+        >>> 'cssregistry.xml' in os.listdir('profiles/default')
+        True
+        >>> cat('profiles/default/cssregistry.xml')
+        <?xml version="1.0"?>
+        <object name="portal_css">
+        <BLANKLINE>
+        <stylesheet title=""
+        id="++resource++quintagroup.theme.ploneexample.stylesheets/main.css"
+        media="screen" rel="stylesheet" rendering="inline"
+        cacheable="True" compression="safe" cookable="True"
+        enabled="1" expression=""/>
+        ...
+        
+        
         Adding JAVASCRIPT resource
         --------------------------
@@ -603,4 +677,6 @@
         Recursing into profiles
         ...
+        Inserting from profiles.zcml_insert ...
+        ...
         Inserting from setuphandlers.py_insert into ...
         ...
@@ -609,4 +685,5 @@
         - 'import' directory was added into root of the theme
         - profiles stuff was updated
+        - profiles.zcml file is updated
         - some stuff into setuphandlers.py module was inserted
         
@@ -618,13 +695,14 @@
         
         
-        2. import_steps.xml was added in profiles/default directory (if does not exist yet),
+        2. import_steps.xml was added in profiles/import_zexps directory,
         which contains additional *quintagroup.theme.ploneexample.import_zexps* step.
         
-        >>> 'import_steps.xml' in os.listdir('profiles/default')
-        True
-        
-        >>> cat('profiles/default/import_steps.xml')
-        <?xml version="1.0"?>
-        <import-steps>
+        >>> 'import_zexps' in os.listdir('profiles')
+        True
+        >>> 'import_steps.xml' in os.listdir('profiles/import_zexps')
+        True
+        
+        >>> cat('profiles/import_zexps/import_steps.xml')
+        <?xml version="1.0"?>
         ...
         <import-step id="quintagroup.theme.ploneexample.import_zexps"
@@ -632,11 +710,26 @@
         handler="quintagroup.theme.ploneexample.setuphandlers.importZEXPs"
         title="My Theme Name: Import zexps objects">
-        <dependency step="skins" />
         Import zexp objects into portal on My Theme Name theme installation
         </import-step>
         <BLANKLINE>
-        </import-steps>
-        
-        3. Check setuphandlers.py module - there must be importZEXPs function defined
+        ...
+        
+        3. profiles.zcml configuration updated with new genericsetup profile for zexps
+        importing.
+        
+        >>> cat('profiles.zcml')
+        <configure
+        ...
+        <genericsetup:registerProfile
+        name="import_zexps"
+        title="My Theme Name: Import ZEXPs"
+        directory="profiles/import_zexps"
+        description='Extension profile for importing objects of the "My Theme Name" Plone theme.'
+        provides="Products.GenericSetup.interfaces.EXTENSION"
+        />
+        <BLANKLINE>
+        ...
+        
+        4. Check setuphandlers.py module - there must be importZEXPs function defined
         
         >>> cat('setuphandlers.py')
@@ -669,8 +762,49 @@
         =========
         
-        0.9 (unreleased)
+        0.2.2 (unreleased)
+        ------------------
+        
+        - Updated import_zexps subtemplate - move this step into
+        separate genericsetup profile
+        [mylan]
+        - Updated tests for changed import_zexps subtemplate
+        [mylan]
+        
+        0.2 (unreleased)
         ----------------
         
-        - Nothing changed yet.
+        - Added new css_dtml_skin subtemplate
+        [mylan]
+        - Added tests for css_dtml_skin subtemplate
+        [mylan]
+        
+        0.14 (unreleased)
+        -----------------
+        
+        - Refactoring theme vars storage-now storing in separate
+        theme_vars.cfg file, without distutils writers [mylan]
+        - Cleanup code [mylan]
+        
+        
+        0.11 (2009-04-13)
+        -----------------
+        
+        - Removed setup.cfg
+        [mylan]
+        
+        
+        0.10 (2009-04-13)
+        -----------------
+        
+        - Updated README
+        [olha]
+        
+        
+        0.9 (2009-04-11)
+        ----------------
+        
+        - Changed package name/namespace to
+        quintagroup.themetemplate.
+        [mylan]
         
         
Index: /quintagroup.themetemplate/trunk/quintagroup.themetemplate.egg-info/SOURCES.txt
===================================================================
--- /quintagroup.themetemplate/trunk/quintagroup.themetemplate.egg-info/SOURCES.txt	(revision 1363)
+++ /quintagroup.themetemplate/trunk/quintagroup.themetemplate.egg-info/SOURCES.txt	(revision 1364)
@@ -1,4 +1,3 @@
 MANIFEST.in
-setup.cfg
 setup.py
 docs/HISTORY.txt
@@ -24,9 +23,12 @@
 quintagroup/themetemplate/localcommands/templates/cssresource/browser/stylesheets/README.txt_tmpl
 quintagroup/themetemplate/localcommands/templates/cssresource/profiles/default/cssregistry.xml_insert
+quintagroup/themetemplate/localcommands/templates/cssskinresource/profiles/default/cssregistry.xml_insert
+quintagroup/themetemplate/localcommands/templates/cssskinresource/skins/+layer_name+/+css_resource_name+.dtml_tmpl
 quintagroup/themetemplate/localcommands/templates/importing/fixes.py_tmpl
+quintagroup/themetemplate/localcommands/templates/importing/profiles.zcml_insert
 quintagroup/themetemplate/localcommands/templates/importing/setuphandlers.py_insert
 quintagroup/themetemplate/localcommands/templates/importing/utils.py_tmpl
 quintagroup/themetemplate/localcommands/templates/importing/import/CONTENT.txt
-quintagroup/themetemplate/localcommands/templates/importing/profiles/default/import_steps.xml_insert
+quintagroup/themetemplate/localcommands/templates/importing/profiles/import_zexps/import_steps.xml_insert
 quintagroup/themetemplate/localcommands/templates/jsresource/browser/configure.zcml_insert
 quintagroup/themetemplate/localcommands/templates/jsresource/browser/scripts/+js_resource_name+_tmpl
@@ -47,6 +49,6 @@
 quintagroup/themetemplate/templates/qplone3_theme/+project+-configure.zcml_tmpl
 quintagroup/themetemplate/templates/qplone3_theme/MANIFEST.in_tmpl
-quintagroup/themetemplate/templates/qplone3_theme/distwriters.py
 quintagroup/themetemplate/templates/qplone3_theme/setup.py_tmpl
+quintagroup/themetemplate/templates/qplone3_theme/theme_vars.cfg_tmpl
 quintagroup/themetemplate/templates/qplone3_theme/+namespace_package+/+namespace_package2+/+package+/__init__.py_tmpl
 quintagroup/themetemplate/templates/qplone3_theme/+namespace_package+/+namespace_package2+/+package+/configure.zcml_tmpl
@@ -62,5 +64,4 @@
 quintagroup/themetemplate/templates/qplone3_theme/+namespace_package+/+namespace_package2+/+package+/browser/templates/README.txt
 quintagroup/themetemplate/templates/qplone3_theme/+namespace_package+/+namespace_package2+/+package+/portlets/__init__.py
-quintagroup/themetemplate/templates/qplone3_theme/+namespace_package+/+namespace_package2+/+package+/portlets/__init__.pyc
 quintagroup/themetemplate/templates/qplone3_theme/+namespace_package+/+namespace_package2+/+package+/portlets/configure.zcml_tmpl
 quintagroup/themetemplate/templates/qplone3_theme/+namespace_package+/+namespace_package2+/+package+/profiles/default/+namespace_package+.+namespace_package2+.+package+_various.txt_tmpl
Index: /quintagroup.themetemplate/trunk/quintagroup.themetemplate.egg-info/entry_points.txt
===================================================================
--- /quintagroup.themetemplate/trunk/quintagroup.themetemplate.egg-info/entry_points.txt	(revision 1363)
+++ /quintagroup.themetemplate/trunk/quintagroup.themetemplate.egg-info/entry_points.txt	(revision 1364)
@@ -6,4 +6,5 @@
           skin_layer    = quintagroup.themetemplate.localcommands.subtemplates:SkinLayerSubTemplate
           css_resource = quintagroup.themetemplate.localcommands.subtemplates:CSSSubTemplate
+          css_dtml_skin = quintagroup.themetemplate.localcommands.subtemplates:CSSSkinLayerSubTemplate
           js_resource = quintagroup.themetemplate.localcommands.subtemplates:JSSubTemplate
           viewlet_order = quintagroup.themetemplate.localcommands.subtemplates:ViewletOrderSubTemplate
@@ -11,10 +12,4 @@
           import_zexps = quintagroup.themetemplate.localcommands.subtemplates:ImportSubTemplate
 
-          [distutils.setup_keywords]
-          theme_vars = quintagroup.themetemplate:assert_dict
-
-          [egg_info.writers]
-          theme_vars.txt = quintagroup.themetemplate:write_map
-
       # -*- Entry points: -*-
       
Index: /quintagroup.themetemplate/trunk/setup.py
===================================================================
--- /quintagroup.themetemplate/trunk/setup.py	(revision 1363)
+++ /quintagroup.themetemplate/trunk/setup.py	(revision 1364)
@@ -2,5 +2,5 @@
 import os
 
-version = '0.14'
+version = '0.2.2'
 
 tests_require=['zope.testing']