Index: quintagroup.transmogrifier.simpleblog2quills/trunk/quintagroup/transmogrifier/simpleblog2quills/tests/source.txt
===================================================================
--- quintagroup.transmogrifier.simpleblog2quills/trunk/quintagroup/transmogrifier/simpleblog2quills/tests/source.txt	(revision 1244)
+++ quintagroup.transmogrifier.simpleblog2quills/trunk/quintagroup/transmogrifier/simpleblog2quills/tests/source.txt	(revision 1488)
@@ -9,5 +9,5 @@
 ... 
 ... [source]
-... blueprint = quintagroup.transmogrifier.simpleblog2quills.tests.source
+... blueprint = quintagroup.transmogrify.simpleblog2quills.tests.source
 ... source = marshall
 ... items =
@@ -19,6 +19,6 @@
 ... blueprint = collective.transmogrifier.sections.tests.pprinter
 ... """
->>> registerConfig(u'quintagroup.transmogrifier.simpleblog2quills.tests.source', source)
->>> transmogrifier(u'quintagroup.transmogrifier.simpleblog2quills.tests.source') # doctest: +ELLIPSIS, +REPORT_NDIFF
+>>> registerConfig(u'quintagroup.transmogrify.simpleblog2quills.tests.source', source)
+>>> transmogrifier(u'quintagroup.transmogrify.simpleblog2quills.tests.source') # doctest: +ELLIPSIS, +REPORT_NDIFF
 {'_files': {'marshall': {'data': ...}},
  '_path': 'plone-blog',
@@ -34,5 +34,5 @@
 ... 
 ... [source]
-... blueprint = quintagroup.transmogrifier.simpleblog2quills.tests.source
+... blueprint = quintagroup.transmogrify.simpleblog2quills.tests.source
 ... allow-empty-items = yes
 ... source = marshall
@@ -45,6 +45,6 @@
 ... blueprint = collective.transmogrifier.sections.tests.pprinter
 ... """
->>> registerConfig(u'quintagroup.transmogrifier.simpleblog2quills.tests.source-with-empties', source)
->>> transmogrifier(u'quintagroup.transmogrifier.simpleblog2quills.tests.source-with-empties') # doctest: +ELLIPSIS, +REPORT_NDIFF
+>>> registerConfig(u'quintagroup.transmogrify.simpleblog2quills.tests.source-with-empties', source)
+>>> transmogrifier(u'quintagroup.transmogrify.simpleblog2quills.tests.source-with-empties') # doctest: +ELLIPSIS, +REPORT_NDIFF
 {'_type': 'Document', '_path': 'not-existing'}
 {'_type': 'File', '_path': 'not-existing'}
Index: quintagroup.transmogrifier.simpleblog2quills/trunk/quintagroup/transmogrifier/simpleblog2quills/tests/test_base.py
===================================================================
--- quintagroup.transmogrifier.simpleblog2quills/trunk/quintagroup/transmogrifier/simpleblog2quills/tests/test_base.py	(revision 1244)
+++ quintagroup.transmogrifier.simpleblog2quills/trunk/quintagroup/transmogrifier/simpleblog2quills/tests/test_base.py	(revision 1488)
@@ -8,9 +8,9 @@
 from quintagroup.transmogrifier.tests import sectionsSetUp
 
-import quintagroup.transmogrifier.simpleblog2quills.tests
+import quintagroup.transmogrify.simpleblog2quills.tests
 
 def sourceSetUp(test):
     sectionsSetUp(test)
-    zcml.load_config('test_import.zcml', quintagroup.transmogrifier.simpleblog2quills.tests)
+    zcml.load_config('test_import.zcml', quintagroup.transmogrify.simpleblog2quills.tests)
 
 def test_suite():
Index: quintagroup.transmogrifier.simpleblog2quills/trunk/quintagroup/transmogrifier/simpleblog2quills/tests/test_import.cfg
===================================================================
--- quintagroup.transmogrifier.simpleblog2quills/trunk/quintagroup/transmogrifier/simpleblog2quills/tests/test_import.cfg	(revision 1244)
+++ quintagroup.transmogrifier.simpleblog2quills/trunk/quintagroup/transmogrifier/simpleblog2quills/tests/test_import.cfg	(revision 1488)
@@ -11,5 +11,5 @@
 
 [source]
-blueprint = quintagroup.transmogrifier.simpleblog2quills.tests.source
+blueprint = quintagroup.transmogrify.simpleblog2quills.tests.source
 source = marshall
 allow-empty-items = yes
Index: quintagroup.transmogrifier.simpleblog2quills/trunk/quintagroup/transmogrifier/simpleblog2quills/tests/test_import.py
===================================================================
--- quintagroup.transmogrifier.simpleblog2quills/trunk/quintagroup/transmogrifier/simpleblog2quills/tests/test_import.py	(revision 1244)
+++ quintagroup.transmogrifier.simpleblog2quills/trunk/quintagroup/transmogrifier/simpleblog2quills/tests/test_import.py	(revision 1488)
@@ -14,4 +14,5 @@
 
 ztc.installProduct('Quills')
+ztc.installProduct('fatsyndication')
 
 @onsetup
Index: quintagroup.transmogrifier.simpleblog2quills/trunk/quintagroup/transmogrifier/simpleblog2quills/tests/test_import.zcml
===================================================================
--- quintagroup.transmogrifier.simpleblog2quills/trunk/quintagroup/transmogrifier/simpleblog2quills/tests/test_import.zcml	(revision 1244)
+++ quintagroup.transmogrifier.simpleblog2quills/trunk/quintagroup/transmogrifier/simpleblog2quills/tests/test_import.zcml	(revision 1488)
@@ -5,5 +5,5 @@
     <utility
         component=".base.Source"
-        name="quintagroup.transmogrifier.simpleblog2quills.tests.source"
+        name="quintagroup.transmogrify.simpleblog2quills.tests.source"
         />
 