Index: quintagroup.transmogrify.simpleblog2quills/trunk/quintagroup/transmogrify/simpleblog2quills/__init__.py
===================================================================
--- quintagroup.transmogrify.simpleblog2quills/trunk/quintagroup/transmogrifier/simpleblog2quills/__init__.py	(revision 1487)
+++ quintagroup.transmogrify.simpleblog2quills/trunk/quintagroup/transmogrify/simpleblog2quills/__init__.py	(revision 1490)
@@ -10,8 +10,8 @@
     profile_registry.registerProfile(
         name="default",
-        title="quintagroup.transmogrifier.simpleblog2quills (enables Large Plone Folder)",
+        title="quintagroup.transmogrify.simpleblog2quills (enables Large Plone Folder)",
         description="Extension profile for applying settings needed to migrate blog.",
         path=profile_path,
-        product="quintagroup.transmogrifier.simpleblog2quills", # this is required
+        product="quintagroup.transmogrify.simpleblog2quills", # this is required
         profile_type=EXTENSION,
         for_=IPloneSiteRoot
Index: quintagroup.transmogrify.simpleblog2quills/trunk/quintagroup/transmogrify/simpleblog2quills/activator.py
===================================================================
--- quintagroup.transmogrify.simpleblog2quills/trunk/quintagroup/transmogrifier/simpleblog2quills/activator.py	(revision 1487)
+++ quintagroup.transmogrify.simpleblog2quills/trunk/quintagroup/transmogrify/simpleblog2quills/activator.py	(revision 1490)
@@ -18,5 +18,5 @@
     pass
 
-from quintagroup.transmogrifier.simpleblog2quills.adapters import IMAGE_FOLDER
+from quintagroup.transmogrify.simpleblog2quills.adapters import IMAGE_FOLDER
 
 class BlogActivatorSection(object):
Index: quintagroup.transmogrify.simpleblog2quills/trunk/quintagroup/transmogrify/simpleblog2quills/adapters.py
===================================================================
--- quintagroup.transmogrify.simpleblog2quills/trunk/quintagroup/transmogrifier/simpleblog2quills/adapters.py	(revision 1487)
+++ quintagroup.transmogrify.simpleblog2quills/trunk/quintagroup/transmogrify/simpleblog2quills/adapters.py	(revision 1490)
@@ -18,5 +18,5 @@
 from quintagroup.transmogrifier.logger import VALIDATIONKEY
 
-from quintagroup.transmogrifier.simpleblog2quills.interfaces import IExportItemManipulator, IBlog
+from quintagroup.transmogrify.simpleblog2quills.interfaces import IExportItemManipulator, IBlog
 
 # URL of the site, where blog is located (this is needed to fix links in entries)
Index: quintagroup.transmogrify.simpleblog2quills/trunk/quintagroup/transmogrify/simpleblog2quills/configure.zcml
===================================================================
--- quintagroup.transmogrify.simpleblog2quills/trunk/quintagroup/transmogrifier/simpleblog2quills/configure.zcml	(revision 1487)
+++ quintagroup.transmogrify.simpleblog2quills/trunk/quintagroup/transmogrify/simpleblog2quills/configure.zcml	(revision 1490)
@@ -4,5 +4,5 @@
     xmlns:zcml="http://namespaces.zope.org/zcml"
     xmlns:transmogrifier="http://namespaces.plone.org/transmogrifier"
-    i18n_domain="quintagroup.transmogrifier.simpleblog2quills">
+    i18n_domain="quintagroup.transmogrify.simpleblog2quills">
 
     <include package="quintagroup.transmogrifier" />
@@ -19,5 +19,5 @@
         <utility
             component=".adapters.ImageFolderSection"
-            name="quintagroup.transmogrifier.simpleblog2quills.imagefolder"
+            name="quintagroup.transmogrify.simpleblog2quills.imagefolder"
             provides="collective.transmogrifier.interfaces.ISectionBlueprint"
             />
@@ -148,5 +148,5 @@
 
     <adapter
-        for="quintagroup.transmogrifier.simpleblog2quills.interfaces.IBaseObject"
+        for="quintagroup.transmogrify.simpleblog2quills.interfaces.IBaseObject"
         provides="quintagroup.transmogrifier.interfaces.IImportDataCorrector"
         factory=".adapters.WorkflowImporter"
@@ -158,5 +158,5 @@
         <utility
             component=".activator.BlogActivatorSection"
-            name="quintagroup.transmogrifier.simpleblog2quills.activator"
+            name="quintagroup.transmogrify.simpleblog2quills.activator"
             provides="collective.transmogrifier.interfaces.ISectionBlueprint"
             />
Index: quintagroup.transmogrify.simpleblog2quills/trunk/quintagroup/transmogrify/simpleblog2quills/export.cfg
===================================================================
--- quintagroup.transmogrify.simpleblog2quills/trunk/quintagroup/transmogrifier/simpleblog2quills/export.cfg	(revision 1487)
+++ quintagroup.transmogrify.simpleblog2quills/trunk/quintagroup/transmogrify/simpleblog2quills/export.cfg	(revision 1490)
@@ -52,5 +52,5 @@
 # in this section you must write you site URL
 [imagefolder]
-blueprint = quintagroup.transmogrifier.simpleblog2quills.imagefolder
+blueprint = quintagroup.transmogrify.simpleblog2quills.imagefolder
 site-urls =
 
Index: quintagroup.transmogrify.simpleblog2quills/trunk/quintagroup/transmogrify/simpleblog2quills/import.cfg
===================================================================
--- quintagroup.transmogrify.simpleblog2quills/trunk/quintagroup/transmogrifier/simpleblog2quills/import.cfg	(revision 1487)
+++ quintagroup.transmogrify.simpleblog2quills/trunk/quintagroup/transmogrify/simpleblog2quills/import.cfg	(revision 1490)
@@ -42,3 +42,3 @@
 
 [activator]
-blueprint = quintagroup.transmogrifier.simpleblog2quills.activator
+blueprint = quintagroup.transmogrify.simpleblog2quills.activator
Index: quintagroup.transmogrify.simpleblog2quills/trunk/quintagroup/transmogrify/simpleblog2quills/itemmanipulator.py
===================================================================
--- quintagroup.transmogrify.simpleblog2quills/trunk/quintagroup/transmogrifier/simpleblog2quills/itemmanipulator.py	(revision 1487)
+++ quintagroup.transmogrify.simpleblog2quills/trunk/quintagroup/transmogrify/simpleblog2quills/itemmanipulator.py	(revision 1490)
@@ -5,5 +5,5 @@
 from collective.transmogrifier.utils import defaultMatcher
 
-from quintagroup.transmogrifier.simpleblog2quills.interfaces import \
+from quintagroup.transmogrify.simpleblog2quills.interfaces import \
     IItemManipulator, IExportItemManipulator, IImportItemManipulator
 
Index: quintagroup.transmogrify.simpleblog2quills/trunk/quintagroup/transmogrify/simpleblog2quills/tests/source.txt
===================================================================
--- quintagroup.transmogrify.simpleblog2quills/trunk/quintagroup/transmogrifier/simpleblog2quills/tests/source.txt	(revision 1487)
+++ quintagroup.transmogrify.simpleblog2quills/trunk/quintagroup/transmogrify/simpleblog2quills/tests/source.txt	(revision 1490)
@@ -9,5 +9,5 @@
 ... 
 ... [source]
-... blueprint = quintagroup.transmogrifier.simpleblog2quills.tests.source
+... blueprint = quintagroup.transmogrify.simpleblog2quills.tests.source
 ... source = marshall
 ... items =
@@ -19,6 +19,6 @@
 ... blueprint = collective.transmogrifier.sections.tests.pprinter
 ... """
->>> registerConfig(u'quintagroup.transmogrifier.simpleblog2quills.tests.source', source)
->>> transmogrifier(u'quintagroup.transmogrifier.simpleblog2quills.tests.source') # doctest: +ELLIPSIS, +REPORT_NDIFF
+>>> registerConfig(u'quintagroup.transmogrify.simpleblog2quills.tests.source', source)
+>>> transmogrifier(u'quintagroup.transmogrify.simpleblog2quills.tests.source') # doctest: +ELLIPSIS, +REPORT_NDIFF
 {'_files': {'marshall': {'data': ...}},
  '_path': 'plone-blog',
@@ -34,5 +34,5 @@
 ... 
 ... [source]
-... blueprint = quintagroup.transmogrifier.simpleblog2quills.tests.source
+... blueprint = quintagroup.transmogrify.simpleblog2quills.tests.source
 ... allow-empty-items = yes
 ... source = marshall
@@ -45,6 +45,6 @@
 ... blueprint = collective.transmogrifier.sections.tests.pprinter
 ... """
->>> registerConfig(u'quintagroup.transmogrifier.simpleblog2quills.tests.source-with-empties', source)
->>> transmogrifier(u'quintagroup.transmogrifier.simpleblog2quills.tests.source-with-empties') # doctest: +ELLIPSIS, +REPORT_NDIFF
+>>> registerConfig(u'quintagroup.transmogrify.simpleblog2quills.tests.source-with-empties', source)
+>>> transmogrifier(u'quintagroup.transmogrify.simpleblog2quills.tests.source-with-empties') # doctest: +ELLIPSIS, +REPORT_NDIFF
 {'_type': 'Document', '_path': 'not-existing'}
 {'_type': 'File', '_path': 'not-existing'}
Index: quintagroup.transmogrify.simpleblog2quills/trunk/quintagroup/transmogrify/simpleblog2quills/tests/test_base.py
===================================================================
--- quintagroup.transmogrify.simpleblog2quills/trunk/quintagroup/transmogrifier/simpleblog2quills/tests/test_base.py	(revision 1487)
+++ quintagroup.transmogrify.simpleblog2quills/trunk/quintagroup/transmogrify/simpleblog2quills/tests/test_base.py	(revision 1490)
@@ -8,9 +8,9 @@
 from quintagroup.transmogrifier.tests import sectionsSetUp
 
-import quintagroup.transmogrifier.simpleblog2quills.tests
+import quintagroup.transmogrify.simpleblog2quills.tests
 
 def sourceSetUp(test):
     sectionsSetUp(test)
-    zcml.load_config('test_import.zcml', quintagroup.transmogrifier.simpleblog2quills.tests)
+    zcml.load_config('test_import.zcml', quintagroup.transmogrify.simpleblog2quills.tests)
 
 def test_suite():
Index: quintagroup.transmogrify.simpleblog2quills/trunk/quintagroup/transmogrify/simpleblog2quills/tests/test_import.cfg
===================================================================
--- quintagroup.transmogrify.simpleblog2quills/trunk/quintagroup/transmogrifier/simpleblog2quills/tests/test_import.cfg	(revision 1487)
+++ quintagroup.transmogrify.simpleblog2quills/trunk/quintagroup/transmogrify/simpleblog2quills/tests/test_import.cfg	(revision 1490)
@@ -11,5 +11,5 @@
 
 [source]
-blueprint = quintagroup.transmogrifier.simpleblog2quills.tests.source
+blueprint = quintagroup.transmogrify.simpleblog2quills.tests.source
 source = marshall
 allow-empty-items = yes
Index: quintagroup.transmogrify.simpleblog2quills/trunk/quintagroup/transmogrify/simpleblog2quills/tests/test_import.py
===================================================================
--- quintagroup.transmogrify.simpleblog2quills/trunk/quintagroup/transmogrifier/simpleblog2quills/tests/test_import.py	(revision 1487)
+++ quintagroup.transmogrify.simpleblog2quills/trunk/quintagroup/transmogrify/simpleblog2quills/tests/test_import.py	(revision 1490)
@@ -14,4 +14,5 @@
 
 ztc.installProduct('Quills')
+ztc.installProduct('fatsyndication')
 
 @onsetup
@@ -20,8 +21,8 @@
     import Products.Five
     zcml.load_config('configure.zcml', Products.Five)
-    import quintagroup.transmogrifier.simpleblog2quills
-    zcml.load_config('configure.zcml', quintagroup.transmogrifier.simpleblog2quills)
-    import quintagroup.transmogrifier.simpleblog2quills.tests
-    zcml.load_config('test_import.zcml', quintagroup.transmogrifier.simpleblog2quills.tests)
+    import quintagroup.transmogrify.simpleblog2quills
+    zcml.load_config('configure.zcml', quintagroup.transmogrify.simpleblog2quills)
+    import quintagroup.transmogrify.simpleblog2quills.tests
+    zcml.load_config('test_import.zcml', quintagroup.transmogrify.simpleblog2quills.tests)
     # this is needed because 'importStep' unknown directive error is raised somewhere
     import Products.GenericSetup
Index: quintagroup.transmogrify.simpleblog2quills/trunk/quintagroup/transmogrify/simpleblog2quills/tests/test_import.zcml
===================================================================
--- quintagroup.transmogrify.simpleblog2quills/trunk/quintagroup/transmogrifier/simpleblog2quills/tests/test_import.zcml	(revision 1487)
+++ quintagroup.transmogrify.simpleblog2quills/trunk/quintagroup/transmogrify/simpleblog2quills/tests/test_import.zcml	(revision 1490)
@@ -5,5 +5,5 @@
     <utility
         component=".base.Source"
-        name="quintagroup.transmogrifier.simpleblog2quills.tests.source"
+        name="quintagroup.transmogrify.simpleblog2quills.tests.source"
         />
 