Index: /quintagroup.seoptimizer/trunk/quintagroup/seoptimizer/browser/keywords.py
===================================================================
--- /quintagroup.seoptimizer/trunk/quintagroup/seoptimizer/browser/keywords.py	(revision 1490)
+++ /quintagroup.seoptimizer/trunk/quintagroup/seoptimizer/browser/keywords.py	(revision 1491)
@@ -75,14 +75,15 @@
                 keyword_on_page =  len(re.findall(u'\\b%s\\b' % keyword, page_text, re.I|re.U))
                 if keyword not in added.keys() and not keyword_on_page:
-                    missing.append(keyword)
+                    missing.append(keyword+u' - 0')
                     added[keyword] = 1
                 if keyword not in finded.keys() and keyword_on_page:
                     finding.append(keyword+u' - '+repr(keyword_on_page))
                     finded[keyword] = 1
-        # return list of missing keywords
-        if missing:
-            msg = ts.utranslate(None, _('missing_keywords', default=u'Next keywords did not appear on the page:\n${missing}', mapping={'missing':'\n'.join(missing)}), context=self.context)
+        # return list of missing and fount keywords
+        if missing or finding:
+            msg = ts.utranslate(None, _('number_keywords', default=u'Number of keywords at page:\n${found}\n${missing}',
+                                mapping={'missing':'\n'.join(missing), 'found': '\n'.join(finding)}), context=self.context)
         else:
-            msg = ts.utranslate(None, _('finded_keywords', default=u'All keywords found on the page!\nMore detailed:\n${found}', mapping={'found': '\n'.join(finding)}), context=self.context)
+            msg = ''
         return msg
 
Index: /quintagroup.seoptimizer/trunk/quintagroup/seoptimizer/locales/quintagroup.seoptimizer.pot
===================================================================
--- /quintagroup.seoptimizer/trunk/quintagroup/seoptimizer/locales/quintagroup.seoptimizer.pot	(revision 1490)
+++ /quintagroup.seoptimizer/trunk/quintagroup/seoptimizer/locales/quintagroup.seoptimizer.pot	(revision 1491)
@@ -4,8 +4,8 @@
 msgid ""
 msgstr ""
-"Project-Id-Version: quintagroup.seoptimizer\n"
-"POT-Creation-Date: 2009-12-25 14:41+0000\n"
+"Project-Id-Version: PACKAGE VERSION\n"
+"POT-Creation-Date: 2009-12-30 17:33+0000\n"
 "PO-Revision-Date: YEAR-MO-DA HO:MI +ZONE\n"
-"Last-Translator: Vitaliy Stepanov <liebster@quintagroup.com>\n"
+"Last-Translator: FULL NAME <EMAIL@ADDRESS>\n"
 "Language-Team: LANGUAGE <LL@li.org>\n"
 "MIME-Version: 1.0\n"
@@ -44,9 +44,4 @@
 #: ./quintagroup.seoptimizer/quintagroup/seoptimizer/browser/templates/seo_controlpanel.pt:30
 msgid "description_seo_dc_metatags"
-msgstr ""
-
-#. Default: "All keywords found on the page!\nMore detailed:\n${found}"
-#: ./quintagroup.seoptimizer/quintagroup/seoptimizer/browser/keywords.py:86
-msgid "finded_keywords"
 msgstr ""
 
@@ -181,7 +176,7 @@
 msgstr ""
 
-#. Default: "Next keywords did not appear on the page:\n${missing}"
+#. Default: "Number of keywords at page:\n${found}\n${missing}"
 #: ./quintagroup.seoptimizer/quintagroup/seoptimizer/browser/keywords.py:84
-msgid "missing_keywords"
+msgid "number_keywords"
 msgstr ""
 
Index: /quintagroup.seoptimizer/trunk/quintagroup/seoptimizer/locales/uk/LC_MESSAGES/quintagroup.seoptimizer.po
===================================================================
--- /quintagroup.seoptimizer/trunk/quintagroup/seoptimizer/locales/uk/LC_MESSAGES/quintagroup.seoptimizer.po	(revision 1490)
+++ /quintagroup.seoptimizer/trunk/quintagroup/seoptimizer/locales/uk/LC_MESSAGES/quintagroup.seoptimizer.po	(revision 1491)
@@ -5,5 +5,5 @@
 msgstr ""
 "Project-Id-Version: quintagroup.seoptimizer\n"
-"POT-Creation-Date: 2009-12-25 14:41+0000\n"
+"POT-Creation-Date: 2009-12-30 17:33+0000\n"
 "PO-Revision-Date: YEAR-MO-DA HO:MI +ZONE\n"
 "Last-Translator: Vitaliy Stepanov <liebster@quintagroup.com>\n"
@@ -44,9 +44,4 @@
 #: ./quintagroup.seoptimizer/quintagroup/seoptimizer/browser/templates/seo_controlpanel.pt:30
 msgid "description_seo_dc_metatags"
-msgstr ""
-
-#. Default: "All keywords found on the page!\nMore detailed:\n${found}"
-#: ./quintagroup.seoptimizer/quintagroup/seoptimizer/browser/keywords.py:86
-msgid "finded_keywords"
 msgstr ""
 
@@ -181,8 +176,8 @@
 msgstr ""
 
-#. Default: "Next keywords did not appear on the page:\n${missing}"
+#. Default: "Number of keywords at page:\n${found}\n${missing}"
 #: ./quintagroup.seoptimizer/quintagroup/seoptimizer/browser/keywords.py:84
-msgid "missing_keywords"
-msgstr ""
+msgid "number_keywords"
+msgstr "Кількість знайдених ключових слів на сторінці:\n${found}\n${missing}"
 
 #. Default: "Content SEO properties have been saved."